<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_HotelService StructType
 * @subpackage Structs
 */
class JP_HotelService extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Board
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Board;
    /**
     * The CheckoutDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CheckoutDate;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Block
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Block;
    /**
     * The Room
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Room
     */
    public $Room;
    /**
     * Constructor method for JP_HotelService
     * @uses JP_HotelService::setCode()
     * @uses JP_HotelService::setBoard()
     * @uses JP_HotelService::setCheckoutDate()
     * @uses JP_HotelService::setName()
     * @uses JP_HotelService::setBlock()
     * @uses JP_HotelService::setRoom()
     * @param string $code
     * @param string $board
     * @param string $checkoutDate
     * @param string $name
     * @param string $block
     * @param \StructType\JP_Room $room
     */
    public function __construct($code = null, $board = null, $checkoutDate = null, $name = null, $block = null, \StructType\JP_Room $room = null)
    {
        $this
            ->setCode($code)
            ->setBoard($board)
            ->setCheckoutDate($checkoutDate)
            ->setName($name)
            ->setBlock($block)
            ->setRoom($room);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_HotelService
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Board value
     * @return string|null
     */
    public function getBoard()
    {
        return $this->Board;
    }
    /**
     * Set Board value
     * @param string $board
     * @return \StructType\JP_HotelService
     */
    public function setBoard($board = null)
    {
        // validation for constraint: string
        if (!is_null($board) && !is_string($board)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($board, true), gettype($board)), __LINE__);
        }
        $this->Board = $board;
        return $this;
    }
    /**
     * Get CheckoutDate value
     * @return string|null
     */
    public function getCheckoutDate()
    {
        return $this->CheckoutDate;
    }
    /**
     * Set CheckoutDate value
     * @param string $checkoutDate
     * @return \StructType\JP_HotelService
     */
    public function setCheckoutDate($checkoutDate = null)
    {
        // validation for constraint: string
        if (!is_null($checkoutDate) && !is_string($checkoutDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkoutDate, true), gettype($checkoutDate)), __LINE__);
        }
        $this->CheckoutDate = $checkoutDate;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_HotelService
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Block value
     * @return string|null
     */
    public function getBlock()
    {
        return $this->Block;
    }
    /**
     * Set Block value
     * @param string $block
     * @return \StructType\JP_HotelService
     */
    public function setBlock($block = null)
    {
        // validation for constraint: string
        if (!is_null($block) && !is_string($block)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($block, true), gettype($block)), __LINE__);
        }
        $this->Block = $block;
        return $this;
    }
    /**
     * Get Room value
     * @return \StructType\JP_Room|null
     */
    public function getRoom()
    {
        return $this->Room;
    }
    /**
     * Set Room value
     * @param \StructType\JP_Room $room
     * @return \StructType\JP_HotelService
     */
    public function setRoom(\StructType\JP_Room $room = null)
    {
        $this->Room = $room;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_HotelService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
